/*******************************************************************************
********************************************************************************
***                                                                           **
***							INTEL CONFIDENTIAL								  **
***                    COPYRIGHT 2011 INTEL CORPORATION                       **
***							All Rights Reserved								  **
***                                                                           **
***                INTEL CORPORATION PROPRIETARY INFORMATION                  **
***                                                                           **
***		The source code contained or described herein and all documents		  **
***		related to the source code ("Material") are owned by Intel			  **
***		Corporation or its suppliers or licensors. Title to the Material	  **
***		remains with Intel Corporation or its suppliers and licensors.		  **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.				  **
***		The Material is protected by worldwide copyright and trade secret	  **
***		laws and treaty provisions. No part of the Material may be used,	  **
***		copied, reproduced, modified, published, uploaded, posted,			  **
***		transmitted, distributed, or disclosed in any way without Intel�s	  **
***		prior express written permission.									  **
***																			  **
***		No license under any patent, copyright, trade secret or other		  **
***		intellectual property right is granted to or conferred upon you by	  **
***		disclosure or delivery of the Materials, either expressly, by		  **
***		implication, inducement, estoppel or otherwise. Any license under	  **
***		such intellectual property rights must be express and approved by	  **
***		Intel in writing.													  **
********************************************************************************/
/*
 * DCMI_ConfigParam_lib.cpp
 *
 *  Created on: Mar 14, 2011
 */

#include "parameters.h"
#include "DCMI_Configuration.h"
#include "DCMI_ConfigParam_lib.h"

const ConfigParamTest::ConformanceVersion ConfigParamTest::m_ConfVer = {0x01,0x05,0x01};

/*
* Export is not supported in visual studio ... figure out version which supports
* just righ now moved to header
*

template <class T> export
TestResult ConfigParamTest::getConfigurationParam(byte_t param, T *out_data)
{
	LOG_DEBUG<<"\nGet Configuration Parameter ("<<std::hex<<std::showbase<<static_cast<int>(param)<<")";

	//Build Command Object
	DCMIClasses::IpmiDCMIRequest request(0x13);
	request.append<byte_t>(param)
		    .append<byte_t>(0x00);

	DCMIClasses::IpmiDCMIResponse response(GET_CONF_PARAM_MIN_RSPLEN, GET_CONF_PARAM_MAX_RSPLEN);

	//Send request data to the transport
	sendIpmiCmd(request, response);

	ConformanceVersion ver = response.getFromData<ConformanceVersion>(1); //3 bytes
	if (ver.major!=m_ConfVer.major || ver.minor!=m_ConfVer.minor || ver.rev!=m_ConfVer.rev)
	{
		LOG_ERR<<"\n\tIncorrect DCMI Specification Conformance Version: "<<std::hex<<std::showbase<<
				static_cast<int>(ver.major)<<"."<<
				static_cast<int>(ver.minor)<<"."<<
				static_cast<int>(ver.rev);
		return TestUtil::TR_FAILURE;
	}

	T param_data = response.getFromData<T>(4); //parameter data

	LOG_DEBUG<<"\n\tReturned parameter data: "
			<<static_cast<int>(param_data)<<", hex: "<<std::hex<<std::showbase
			<<static_cast<int>(param_data);

	if (out_data)
	{
		*out_data = param_data;
	}

	return TestUtil::TR_SUCCESS; //pass
}

template <class T> export
void ConfigParamTest::setConfigurationParam(byte_t param, T param_data)
{
	//Build Command Object
	LOG_DEBUG<<"\nSet Configuration Parameter ("<<std::hex<<std::showbase<<static_cast<int>(param)<<")\n";

	DCMIClasses::IpmiDCMIRequest request(0x12);
	request.append<byte_t>(param)
		   .append<byte_t>(0x00)
		   .append<T>(param_data);

	DCMIClasses::IpmiDCMIResponse response(SET_CONF_PARAM_MIN_RSPLEN, SET_CONF_PARAM_MAX_RSPLEN);

	//Send request data to the transport
	sendIpmiCmd(request, response);//, SET_CONF_PARAM_MIN_RSPLEN, SET_CONF_PARAM_MAX_RSPLEN);
}
*/
