/*******************************************************************************
********************************************************************************
***                                                                           **
***							INTEL CONFIDENTIAL								  **
***                    COPYRIGHT 2008, 2011 INTEL CORPORATION                 **
***							All Rights Reserved								  **
***                                                                           **
***                INTEL CORPORATION PROPRIETARY INFORMATION                  **
***                                                                           **
***		The source code contained or described herein and all documents		  **
***		related to the source code ("Material") are owned by Intel			  **
***		Corporation or its suppliers or licensors. Title to the Material	  **
***		remains with Intel Corporation or its suppliers and licensors.		  **
***		The Material contains trade secrets and proprietary and confidential  **
***		information of Intel or its suppliers and licensors.				  **
***		The Material is protected by worldwide copyright and trade secret	  **
***		laws and treaty provisions. No part of the Material may be used,	  **
***		copied, reproduced, modified, published, uploaded, posted,			  **
***		transmitted, distributed, or disclosed in any way without Intel?s	  **
***		prior express written permission.									  **
***																			  **
***		No license under any patent, copyright, trade secret or other		  **
***		intellectual property right is granted to or conferred upon you by	  **
***		disclosure or delivery of the Materials, either expressly, by		  **
***		implication, inducement, estoppel or otherwise. Any license under	  **
***		such intellectual property rights must be express and approved by	  **
***		Intel in writing.													  **
********************************************************************************/

#ifndef __VERSION_H__
#define __VERSION_H__


#define MAJOR_VERSION  1
#define MINOR_VERSION  5
#define QUICK_FIX_NUMBER  0
#define VER_BUILD  31

/*
 * Specification version ... info */
#define SPEC_VER_MAJOR          MAJOR_VERSION    /**< Major Specification Version */
#define SPEC_VER_MINOR          MINOR_VERSION    /**< Minor Specification Version */

#include "VersionCommon.h"

/** Combined file version string */
#define TOOL_REV	VER_PRODUCTVERSION_STR
#define SPEC_REV 	__stringify(SPEC_VER_MAJOR) "." __stringify(SPEC_VER_MINOR)

#endif
